package com.its.op.service.its.incident;

import com.its.op.config.ApplicationConfig;
import com.its.op.dao.repository.its.code.TbCmmnCdRepository;
import com.its.op.dao.repository.its.ifsc.TbIfscLinkRltnRepository;
import com.its.op.dao.repository.its.incident.TbIncdOcrrRepository;
import com.its.op.dao.repository.its.vms.TbVmsCtlrRepository;
import com.its.op.dao.repository.its.vms.TbVmsRltnIfscRepository;
import com.its.op.dao.repository.its.vms.TbVmsIfscRltnIfscRepository;
import com.its.op.dto.its.code.IncdCodeDto;
import com.its.op.dto.its.incident.IncdNewIdDto;
import com.its.op.dto.its.incident.TbIncdOcrrDto;
import com.its.op.dto.its.vms.TbVmsCtlrDto;
import com.its.op.entity.its.code.TbCmmnCd;
import com.its.op.entity.its.incident.TbIncdOcrr;
import com.its.op.entity.its.vms.TbVmsCtlr;
import com.its.op.global.CodeManager;
import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.ArrayList;
import java.util.List;
import java.util.NoSuchElementException;
import java.util.Optional;

@Slf4j
@RequiredArgsConstructor
@Service
public class TbIncdOcrrService {

    private final TbIncdOcrrRepository repo;
    private final TbIfscLinkRltnRepository linkRltnRepo;
    private final TbVmsIfscRltnIfscRepository vmsLinkIfscRepo;
    private final TbVmsRltnIfscRepository vmsIfscRltnRepo;
    private final TbVmsCtlrRepository vmsRepo;
    private final ApplicationConfig applicationConfig;

    private final TbCmmnCdRepository codeRepo;

    // 데이터 1건 조회, 없으면 exception
    private TbIncdOcrr requireOne(String id) throws NoSuchElementException {
        Optional<TbIncdOcrr> info = this.repo.findById(id);
        if (info.isPresent()) {
            return info.get();
        }
        else {
            throw new NoSuchElementException("데이터가 존재하지 않습니다: " + id);
        }
//        return repo.findById(id)
//                .orElseThrow(() -> new NoSuchElementException("데이터가 존재하지 않습니다: " + id));
    }

    // 전체 데이터 조회
    @Transactional(readOnly = true)
    public List<TbIncdOcrrDto> findAll() {
        List<TbIncdOcrrDto> result = new ArrayList<>();
        List<TbIncdOcrr> data = this.repo.findAll();
        for (TbIncdOcrr entity : data) {
            result.add(entity.toDto());
        }
        return result;
    }

    // 데이터 1건 조회(기존 데이터가 반드시 존재해야 함)
    @Transactional(readOnly = true)
    public TbIncdOcrrDto findById(String id) {
        TbIncdOcrr entity = requireOne(id);
        return entity.toDto();
    }

    // 데이터 변경
    @Transactional
    public TbIncdOcrrDto updateById(String id, TbIncdOcrrDto.TbIncdOcrrUpdReq req) {
        TbIncdOcrr entity = requireOne(id);
        entity.updateInfo(req);
        this.repo.save(entity);
        return entity.toDto();
    }

    // 데이터 변경 또는 생성-목록(데이터가 존재하면 업데이트 없으면 신규로 생성)
    @Transactional
    public List<TbIncdOcrrDto> mergeInfoList(List<TbIncdOcrrDto.TbIncdOcrrUpdReq> reqList) {
        List<TbIncdOcrrDto> result = new ArrayList<>();
        for (TbIncdOcrrDto.TbIncdOcrrUpdReq req : reqList) {
            TbIncdOcrr obj = req.toEntity();
            this.repo.save(obj);
            result.add(obj.toDto());
        }
        return result;
    }

    // 데이터 변경 또는 생성-개별(데이터가 존재하면 업데이트 없으면 신규로 생성)
    @Transactional
    public TbIncdOcrrDto mergeInfo(TbIncdOcrrDto.TbIncdOcrrUpdReq req) {
        TbIncdOcrr obj = req.toEntity();
        this.repo.save(obj);
        return obj.toDto();
    }

    // 정보 삭제-개별, 데이터 존재하지 않으면 Exception
    @Transactional
    public TbIncdOcrrDto deleteById(String id) {
        TbIncdOcrr entity = requireOne(id);
        this.repo.deleteById(id);
        return entity.toDto();
    }

    // 정보 삭제-목록, 존재하는 데이터 만 삭제
    @Transactional
    public List<TbIncdOcrrDto> deleteByIds(List<String> ids) {
        List<TbIncdOcrrDto> result = new ArrayList<>();
        for (String id : ids) {
            Optional<TbIncdOcrr> obj = this.repo.findById(id);
            if (obj.isPresent()) {
                this.repo.deleteById(id);
                result.add(obj.get().toDto());
            }
        }
        return result;
    }

    /**
     * 신규 돌발 ID 조회
     * @param
     * @return
     */
    @Transactional(readOnly = true)
    public IncdNewIdDto getNewIncdId() {
        String centerId = this.applicationConfig.getCenterId();
        String newId = this.repo.getNewIncdId(centerId);
        IncdNewIdDto result = IncdNewIdDto.builder()
                .incdOcrrId(centerId + newId)
                .build();
        return result;
    }
    /**
     * 신규돌발정보조회
     * @return
     */
    @Transactional(readOnly = true)
    public List<TbIncdOcrrDto> findAllRegistered() {
        List<TbIncdOcrrDto> result = new ArrayList<>();
        List<TbIncdOcrr> data = this.repo.findAll();
        data.forEach(obj -> {
            if (CodeManager.INCD_PRGR_STEP_ISS1.equals(obj.getIncdPrgrStepCd())) {
                // 접수/미확인 단계이면서
                if (CodeManager.INCD_ORGN_IST5.equals(obj.getIncdOrgnCd()) ||
                    CodeManager.INCD_ORGN_IST3.equals(obj.getIncdOrgnCd())) {
                    // 도로교통공단 또는 연계 돌발인 경우 신규 돌발 정보 처리
                    result.add(obj.toDto());
                }
            }
        });
        return result;
    }

    /**
     * 진행중돌발정보조회
     * @return
     */
    @Transactional(readOnly = true)
    public List<TbIncdOcrrDto> findAllProgress() {
        List<TbIncdOcrrDto> result = new ArrayList<>();
        List<TbIncdOcrr> data = this.repo.findAll();
        data.forEach(obj -> {
            // 현재 진행중인 돌발 정보 조회
            if (CodeManager.INCD_PRGR_STEP_ISS2.equals(obj.getIncdPrgrStepCd())) {
                result.add(obj.toDto());
            }
        });
        return result;
    }

    /**
     * 진행/종료돌발 이력정보조회
     * @param fromDt
     * @param toDt
     * @return
     */
    @Transactional(readOnly = true)
    public List<TbIncdOcrrDto> findAllProgressHistory(String fromDt, String toDt) {
        List<TbIncdOcrrDto> result = new ArrayList<>();
        List<TbIncdOcrr> data = this.repo.findAllProgressHistory(fromDt, toDt);
        data.forEach(obj -> {
            // 현재 진행중이거나 돌발종료 처리된 돌발 정보 조회
            if (CodeManager.INCD_PRGR_STEP_ISS2.equals(obj.getIncdPrgrStepCd()) ||
                CodeManager.INCD_PRGR_STEP_ISS3.equals(obj.getIncdPrgrStepCd())) {
                result.add(obj.toDto());
            }
        });
        return result;
    }

    /**
     * 돌발구간에 해당하는 VMS 목록 조회
     * @param linkId
     * @return
     */
    @Transactional(readOnly = true)
    public List<TbVmsCtlrDto> findAllVmsList(Long linkId) {
        List<TbVmsCtlrDto> result = new ArrayList<>();

        // LINK ID 로 구성된 정보제공구간 ID 를 구한다.
        List<Long> ifscIds = this.linkRltnRepo.findIfscIdByLinkId(linkId);
        if (ifscIds.size() == 0) {
            return result;
        }

        // IFSC ID 로 구성된 VMS IFSC ID 목록을 조회한다.
        List<Long> vmsIfscIds = this.vmsLinkIfscRepo.findVmsIfscIdByIfscId(ifscIds);
        if (vmsIfscIds.size() == 0) {
            log.info("{}, IfscIds: {}", linkId, ifscIds);
            return result;
        }

        // VMS IFSC ID 로 구성된 VMS 목록을 조회한다.
        List<Long> vmsIds = this.vmsIfscRltnRepo.findVmsByVmsIfscId(vmsIfscIds);
        if (vmsIds.size() == 0) {
            log.info("{}, IfscIds: {}, VmsIfscIds: {}", linkId, ifscIds, vmsIfscIds);
            return result;
        }

        log.info("{}, IfscIds: {}, VmsIfscIds: {}, vms: {}", linkId, ifscIds, vmsIfscIds, vmsIds);

        // VMS 제어기 번호에 해당 되는 제어기 정보를 조회한다.
        List<TbVmsCtlr> vmsObjs = this.vmsRepo.findAllListByIds(vmsIds);
        vmsObjs.forEach(obj -> {
            result.add(obj.toDto());
        });
        return result;
    }

    /**
     * 돌발정보 오보처리
     * @param id
     * @return
     */
    @Transactional
    public TbIncdOcrrDto misInfo(String id) {
        TbIncdOcrr entity = requireOne(id);
        entity.setMisInfo();
        this.repo.save(entity);
        return entity.toDto();
    }

    /**
     * 돌발정보 관리 코드 정보 조회
     * @param cmmnClsfCd
     * @return
     */
    @Transactional
    public List<IncdCodeDto> findAllByCmmnClsfCd(String cmmnClsfCd) {
        List<IncdCodeDto> result = new ArrayList<>();
        List<TbCmmnCd> data = this.codeRepo.findAllByCmmnClsfCd(cmmnClsfCd);
        data.forEach(obj -> {
            if (("Y").equals(obj.getUseYn())) {
                result.add(IncdCodeDto.makeDto(obj));
            }
        });
        return result;
    }

}
